function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
import React, { useEffect, useRef, useState } from 'react';
import G6 from '@antv/g6';
import './customNode';
var KinshipChart = function KinshipChart(_ref) {
  var style = _ref.style,
    className = _ref.className,
    dataSource = _ref.dataSource;
  var containerRef = useRef(null);
  var _useState = useState(),
    _useState2 = _slicedToArray(_useState, 2),
    graph = _useState2[0],
    setGraph = _useState2[1];
  useEffect(function () {
    initGraph();
    return function () {
      graph === null || graph === void 0 ? void 0 : graph.destroy();
    };
  }, []);
  function initGraph() {
    if (!containerRef.current) return;
    var graph_ = new G6.Graph({
      container: containerRef.current,
      width: containerRef.current.clientWidth,
      height: containerRef.current.clientHeight,
      plugins: [new G6.ToolBar()],
      layout: {
        type: 'dagre',
        rankdir: 'LR',
        nodesepFunc: function nodesepFunc() {
          return 50;
        },
        ranksep: 70,
        controlPoints: true
      },
      defaultNode: {
        type: 'skinshipNode',
        // 左右两边各一个锚点
        anchorPoints: [[0, 0.5], [1, 0.5]]
      },
      defaultEdge: {
        type: 'polyline',
        style: {
          radius: 20,
          offset: 45,
          lineWidth: 1,
          stroke: '#165DFF',
          endArrow: {
            path: G6.Arrow.triangle(6, 8, 10),
            d: 10,
            fill: '#165DFF'
          }
        }
      },
      modes: {
        default: ['drag-canvas', 'zoom-canvas', 'click-select']
      },
      fitView: false
    });
    graph_.data({
      nodes: dataSource === null || dataSource === void 0 ? void 0 : dataSource.nodes.map(function (node) {
        return _objectSpread(_objectSpread({}, node), {}, {
          id: String(node.id)
        });
      }),
      edges: dataSource === null || dataSource === void 0 ? void 0 : dataSource.links.map(function (link) {
        return {
          source: String(link.source),
          target: String(link.target)
        };
      })
    });
    graph_.render();
    setGraph(graph_);
  }
  return /*#__PURE__*/React.createElement("div", {
    style: _objectSpread({
      width: '100%',
      height: '100%',
      position: 'relative',
      overflow: 'hidden'
    }, style),
    ref: containerRef,
    className: className
  });
};
export default KinshipChart;